unit UStack;

interface

type
  uk = ^zveno;

  zveno = record
    data: pointer;
    next: uk;
  end;

  TStack = class
  private
    Fhead: uk;
    Fcount: integer;
  protected
  public
    constructor Create; //   
    procedure Push(el: pointer); //    
    function Pop: pointer; //    
    function GetLast: pointer; //    
    function IsEmpty: boolean; //   
    procedure Clear; //  

    property Count: integer //   
      read Fcount;
  end;

implementation

procedure TStack.Clear; //  
begin
  while Fhead <> nil do Pop;
end;

constructor TStack.Create; //   
begin
  Fhead := nil;
  Fcount := 0;
end;

function TStack.GetLast: pointer; //   
begin
  if Fhead = nil then
    result := nil
  else
    result := Fhead.data;
end;

function TStack.IsEmpty: boolean; //    
begin
  result := Fhead = nil;
end;

function TStack.Pop: pointer; //    
var
  buf: uk;
begin
  if Fhead = nil then
    result := nil
  else
  begin
    result := Fhead.data;
    buf := Fhead;
    Fhead := Fhead.next;
    dispose(buf);
    dec(Fcount);
  end;
end;

procedure TStack.Push(el: pointer); //    
var
  buf: uk;
begin
  new(buf);
  buf.data := el;
  buf.next := Fhead;
  Fhead := buf;
  inc(Fcount);
end;

end.
